//X[p[NX`ǂݍ
dofile("script/common/util" + ext);

loadFile("script/common/allLoad");
loadFile("script/stageLabo/objects/mouse");
loadFile("script/stageLabo/objects/lamp");

//Locals
taskManager <- TaskManager();
effectGenerator <- EffectGeneratorClass();
itemManager <- ItemManager();
medalManager <- MedalManager();

lightType <- 0;
lightChanged <- true;

//Tasks
playerTask <- null;
cameraTask <- null;

//gameData
gameMode <- "Walk";

//PauseManager
isPushedPause <- true;
pauseManager <- PauseManager();

//EventData
eventData <- EventData();
sceneChangeCount <- 0;
sceneChangeMaxCount <- 20;

underMapY <- -1000.0;

isPushedRButton <- true;

function _changeScene()
{
  sceneChangeCount=0;
  gameMode = "FeadOut";
}

//Jn
function onLoad(){
  //Wave
  waveDev <- loadWave("dev.wav");

  //tB[h
  setDrawFieldFlatMode(false);
  loadField("data\\field\\submap\\labo\\field.x");

  //eNX`
  loadTexture(0,"data\\texture\\waterMark.bmp");
  loadTexture(1,"data\\texture\\textures.bmp");
  loadTexture(2,"data\\texture\\items.bmp");
  loadTexture(9,"data\\texture\\sceneChange.bmp");
  
  taskManager.clear();

  //PlayerClass̃CX^X쐬AǗNXɒǉ
  local task = MonkeyClass();
  task.pm.x = getData("playerX").tofloat();
  task.pm.y = getData("playerY").tofloat();
  task.pm.z = getData("playerZ").tofloat();
  task.pm.ry = getData("playerRY").tofloat();
  taskManager.add(task);
  task.pm.update();
  playerTask = task.weakref();
  playerTask.run();
  
  local shadowTask = ShadowClass();
  shadowTask.refObj = task.weakref();
  shadowTask.pm.update();
  taskManager.add(shadowTask);

  local task = MouseClass();
  task.name = "mouse";
  task.pm.x = -25.0;
  task.pm.y = 1.0;
  task.pm.z = 0.0;
  task.pm.ry = 270.0;
  task.isCanHold = false;
  taskManager.add(task);
  task.pm.update();
  task.loadPorigon("data\\mouse\\mouse.cha");
  task.pm.drawY = 3.0;

  local task = NoHitObjClass();
  task.pm.x = 0.0;
  task.pm.y = 0.0;
  task.pm.z = 0.0;
  task.pm.ry = 0.0;
  task.isCanHold = false;
  taskManager.add(task);
  task.loadPorigon("data\\field\\submap\\labo\\labo.cha");
  task.pm.update();

  local task = ObjClass();
  task.pm.x = -16.0;
  task.pm.y = 0.0;
  task.pm.z = 0.0;
  task.pm.ry = 180.0;
  task.isCanHold = false;
  taskManager.add(task);
  task.loadPorigon("data\\field\\submap\\labo\\table.cha");
  task.pm.update();

  local task = NoHitObjClass();
  task.pm.x = -8.0;
  task.pm.y = -1.0;
  task.pm.z = 0.0;
  task.pm.ry = 180.0;
  task.isCanHold = false;
  taskManager.add(task);
  task.loadPorigon("data\\field\\submap\\labo\\chair.cha");
  task.pm.update();

  initMedal();

  //camera
  cameraTask = CameraClass();
  cameraTask.init();
  

  //Fog
  setFogEnable(false);
  updateFog();

  setFieldRenderMinDistance(80.0);
  setFieldRenderMaxDistance(1000.0);

  setLightVec(-20.0,
              15.0,
              0.0);
  setLightColor(1.0,1.0,1.0);
  setLightDistance(70.0);
  setLightPower(0.6);
  setLightType(1);
  updateLight();

  //^XN̗L
  taskManager.refresh();
  
  //IuWFNgǗNXDꊇs
  taskManager.run();

  //^XN̗L
  taskManager.refresh();
  
  cameraTask.run();

  if(isLoadMidi("Kbgm008-simalife.mid")==false){
    loadMidi("Kbgm008-simalife.mid");
    playMidi(0);
  }

  gameMode = "FeadIn";
}

//C
function onProc(){
  switch(gameMode){
    case "FeadIn":
      sceneChangeCount++;
      if(sceneChangeCount >= sceneChangeMaxCount){
        gameMode = "Walk";
      }
    break;

    case "Walk":
      if(getInputButton(4)){
        if(isPushedPause==false){
          pauseManager.setPause();
        }
        isPushedPause = true;
      }
      else{
        isPushedPause = false;
        
        //vC[̓
        playerTask.isLeft = getInputLeft();
        playerTask.isRight = getInputRight();
        playerTask.isUp = getInputUp();
        playerTask.isDown = getInputDown();
        playerTask.isButton1 = getInputButton(0);
        playerTask.isButton2 = getInputButton(1);

        //J̈ړ
        cameraTask.run();

        //IuWFNgǗNXDꊇs
        taskManager.run();

        //^XN̗L
        taskManager.refresh();
      }
    break;
    case "Event":
      //vC[̓
      playerTask.isLeft = false;
      playerTask.isRight = false;
      playerTask.isUp = false;
      playerTask.isDown = false;
      playerTask.isButton1 = false;
      playerTask.isButton2 = false;

      cameraTask.run();
      playerTask.mode = enumMode.EVENT;

      //IuWFNgǗNXDꊇs
      taskManager.run();

      //^XN̗L
      taskManager.refresh();

      //Cxg
      eventData.eventProc();
    break;

    case "Medal":
      //vC[̓
      playerTask.isLeft = false;
      playerTask.isRight = false;
      playerTask.isUp = false;
      playerTask.isDown = false;
      playerTask.isButton1 = false;
      playerTask.isButton2 = false;

      playerTask.mode = enumMode.EVENT;

      medalProc();
    break;

    case "Pause":
      if(getInputButton(4)){
        if(isPushedPause==false){
          gameMode = "Walk";
        }
        isPushedPause = true;
      }
      else{
        isPushedPause = false;
      }

      if(gameMode == "Pause"){
        pauseManager.pauseProc();
      }
      else{
        playWave(pauseManager.wavePause);
      }
    break;

    case "FeadOut":
      sceneChangeCount++;
      if(sceneChangeCount >= sceneChangeMaxCount){
        setMainLoopEnd();
      }
    break;
  }

  //medalCheck
  ::checkMedalWalk();

  if(gameMode == "Walk"){
    local dis= sqrt(pow(playerTask.pm.x-30.0,2) + pow(playerTask.pm.z-1.5,2));
    if(dis<5.0){
      if(playerTask.isButton1){
        setData("nextPath","script/stageMain/stage");
        setData("playerX","140.0");
        setData("playerY","52.0");
        setData("playerZ","90.0");
        setData("playerRY","270.0");
        _changeScene();
      }
      else{
        playerTask.sendMessage("OutSpotEvent",playerTask.index);
      }
    }
  }
//test!

  if(isDebug() && getMouseRButton()){
    if(isPushedRButton == false){
      setMainLoopEnd();
    }
    isPushedRButton = true;
  }
  else{
    isPushedRButton = false;
  }
}

//`揈
function onDraw(){
  drawTextureFirst(-1,
    320,240,640,480,
    0,
    0,0,8,8,
    0.0,0.0,0.0,1.0,
    0.5,0.5);
  drawField();
  drawUnderMap();
  //IuWFNgǗNXDꊇs
  taskManager.draw();

  switch(gameMode){
    case "Event":
      eventData.eventDraw();
    break;
    case "Medal":
      medalDraw();
    break;
    case "Pause":
      pauseManager.pauseDraw();
    break;
    case "FeadIn":
      local per = sceneChangeCount.tofloat() / sceneChangeMaxCount.tofloat();
      local size = (8.0 + 1536.0*sin(per*PI*0.5)).tointeger();
      local centerX=320;
      local centerY=240;
      drawTextureLast(9,
        centerX,centerY,size,size,
        0,
        0,0,256,256,
        0.0,0.0,0.0,1.0,
        0.5,0.5);
      drawTextureLast(-1,
        centerX+size/2,0,640,480,
        0,
        0,0,256,256,
        0.0,0.0,0.0,1.0,
        0.0,0.0);
      drawTextureLast(-1,
        centerX-size/2,0,640,480,
        0,
        0,0,256,256,
        0.0,0.0,0.0,1.0,
        1.0,0.0);
      drawTextureLast(-1,
        0,centerY-size/2,640,480,
        0,
        0,0,256,256,
        0.0,0.0,0.0,1.0,
        0.0,1.0);
      drawTextureLast(-1,
        0,centerY+size/2,640,480,
        0,
        0,0,256,256,
        0.0,0.0,0.0,1.0,
        0.0,0.0);
    break;
    case "FeadOut":
      local per = 1.0 - sceneChangeCount.tofloat() / sceneChangeMaxCount.tofloat();
      local size = (8.0 + 1536.0*sin(per*PI*0.5)).tointeger();
      local centerX=320;
      local centerY=240;
      drawTextureLast(9,
        centerX,centerY,size,size,
        0,
        0,0,256,256,
        0.0,0.0,0.0,1.0,
        0.5,0.5);
      drawTextureLast(-1,
        centerX+size/2,0,640,480,
        0,
        0,0,256,256,
        0.0,0.0,0.0,1.0,
        0.0,0.0);
      drawTextureLast(-1,
        centerX-size/2,0,640,480,
        0,
        0,0,256,256,
        0.0,0.0,0.0,1.0,
        1.0,0.0);
      drawTextureLast(-1,
        0,centerY-size/2,640,480,
        0,
        0,0,256,256,
        0.0,0.0,0.0,1.0,
        0.0,1.0);
      drawTextureLast(-1,
        0,centerY+size/2,640,480,
        0,
        0,0,256,256,
        0.0,0.0,0.0,1.0,
        0.0,0.0);
    break;
  }
}

//I
function onUnload(){
  unloadWave(waveDev);

  unloadTexture(0);
  unloadTexture(1);
  unloadTexture(2);
  unloadTexture(9);

  //IuWFNgǗNX̃Xbg폜
  taskManager.clear();
  unloadUnderMap();
  pauseManager.dispose();//wave̔j
  
  setNextFilePath(getData("nextPath")+ext);
}

//vC[QbgԂɕύX
function setPlayerGetStatus()
{
  playerTask.pm.ry = cameraTask.cameraRad+180.0;
  if(playerTask.pm.ry >= 360.0){
    playerTask.pm.ry -= 360.0;
  }
  local rad = playerTask.pm.ry*PI/180.0;
  eventData.refObj.pm.y = playerTask.pm.y + 8.0;
  eventData.refObj.pm.x = playerTask.pm.x - sin(rad)*2.0;
  eventData.refObj.pm.z = playerTask.pm.z - cos(rad)*2.0;
  playerTask.pm.animeIndex = 4;
  playerTask.pm.animeFrame = 0.0;
  playerTask.isCanChangeMode = false;
}
