function load(){
FishClass <- class extends ItemBaseClass
{

  pm=null;
  baseRY=0.0;
  mode = 0;
  count=0;
  speed = 0.25;
  isGet = false;
  
  static MAX_COUNT = 20;
  static MODE_NORMAL = 0;
  static MODE_REVERSE = 1;
  static MODE_RUNAWAY = 2;
  
  //public
  constructor(){
    type = "FishClass";
    pm = PorigonManager();
    mode = MODE_NORMAL;
    pm.drawY = 1.0;
    pm.hitRadius = 0.25;

    isEnableMessage = false;
  }
  
  function checkBaseRY(){
    local oldX = pm.x;
    local oldY = pm.y;
    local oldZ = pm.z;
    local tempRY = baseRY;
    
    local rad = 0.0;
    local loopCount = 0;
    local resultField = 0;
    
    while(loopCount < 90){
      rad = tempRY*PI/180.0;
      pm.x = oldX + sin(rad)*3.0;
      pm.y = -10.0;
      pm.z = oldZ + cos(rad)*3.0;
      resultField = pm.checkField(true);
      
      if(pm.y < underMapY-2.0 && resultField >= -1){
        baseRY = tempRY;
        loopCount = 999;
      }
      tempRY += 4.0;
      if(tempRY >= 360.0){
        tempRY -= 360.0;
      }
      loopCount++;
    }
    pm.x = oldX;
    pm.y = oldY;
    pm.z = oldZ;
  }

  function run(){
    local oldX = pm.x;
    local oldY = pm.y;
    local oldZ = pm.z;
    
    if(isGet){
      return;
    }

    if(count<=0){
      switch(mode){
        case MODE_NORMAL:
          baseRY += (rand()%30).tofloat()-15.0;
          speed = 0.25;
          checkBaseRY();
        break;
        case MODE_REVERSE:
          baseRY += (rand()%180).tofloat()-90.0;
          baseRY = baseRY+180.0;
          while(baseRY >= 360.0){
            baseRY -= 360.0;
          }
          checkBaseRY();
          speed = 0.25;
        break;
        case MODE_RUNAWAY:
          local tempX = pm.x - playerTask.pm.x;
          local tempZ = pm.z - playerTask.pm.z;
          if(tempX == 0.0){
            if(tempZ < 0.0){
              baseRY = 0.0;
            }
            else{
              baseRY = 180.0;
            }
          }
          else{
            baseRY = atan2(tempZ,tempX)*180.0/PI;
          }
          baseRY = 360.0-baseRY+90.0+(rand()%180).tofloat()-90.0;
          while(baseRY >= 360.0){
            baseRY -= 360.0;
          }
          while(baseRY < 0.0){
            baseRY += 360.0;
          }
          checkBaseRY();
          speed = 2.0;
        break;
      }
      
      count = MAX_COUNT;
      pm.ry = baseRY+180.0;
      if(pm.ry >= 360.0){
        pm.ry -= 360.0;
      }
      
      mode = MODE_NORMAL;
    }
    else{
      local rad = baseRY*PI/180.0;
      pm.x += sin(rad)*speed;
      pm.y = -10.0;
      pm.z += cos(rad)*speed;

      local resultField = pm.checkField(true);
      
      if(pm.y >= underMapY-1.0 || resultField<=-2){
        mode = MODE_REVERSE;
      }
      if(speed<=0.25 && mode!=MODE_RUNAWAY){
        local dis = sqrt(pow(playerTask.pm.x-pm.x,2) + pow(playerTask.pm.z-pm.z,2));
        if(dis <= 20.0){
          mode = MODE_RUNAWAY;
        }
      }
      if(mode != MODE_NORMAL){
        count = 0;
        pm.x = oldX;
        pm.y = oldY;
        pm.z = oldZ;
      }
      else{
        count--;
      }
    }

    //anime
    pm.animeFrame += 1.0;
    local maxAnimeFrame = pm.getMaxAnimeFrame(pm.animeIndex);
    if(pm.animeFrame >= maxAnimeFrame){
      pm.animeFrame -= maxAnimeFrame;
    }

    pm.update();

    local dis = sqrt(pow(playerTask.pm.x-pm.x,2) + pow(playerTask.pm.z-pm.z,2));
    if(gameMode!="Event" && dis < 2.0){
      ::eventData.setEvent(this);
      isGet = true;
    }
  }

  function draw(){
    pm.draw();
  }
  
  function loadPorigon(filename){
    pm.index = index;
    if(pm.load(filename)==false){
      print("error");
    }
  }

  //Cxg(CxgAIuWFNgj
  function event(eventName,argObj)
  {
    switch(eventName){
      case "onUnload":
        pm.unload();
      break;
    }
  }

  //eventProc
  function eventProc(){
    ::eventData.windowBaseY = 15.0;
    switch(::eventData.eventCount){
      case 0:
        ::eventData.isAutoEvent = true;
        ::setPlayerGetStatus();
        playWave(waveGetBanana);
      break;
      case 1:
        pm.y = ::playerTask.pm.y + 8.0;
        ::eventData.isTalkPlayer = true;
        ::eventData.voiceMsg = "/A܂";
        ::eventData.eventMsg = "Ȃ\n܂";
        ::eventData.refObj.pm.ry += 10.0;
        if(::eventData.refObj.pm.ry >= 360.0){
          ::eventData.refObj.pm.ry -= 360.0;
        }
      break;
      case 2:
        pushedButton1=true;
        ::itemManager.set(ItemClass.FISH,1);
        _setItemData();
        EffectGeneratorClass.createItemGet(ItemClass.FISH,
                                           ::eventData.refObj.pm.x,
                                           ::eventData.refObj.pm.y+3.0,
                                           ::eventData.refObj.pm.z);
        ::eventData.isAutoEvent = true;
        ::eventData.waitIconCount=0;
      break;
      default:
        pushedButton1=true;
        if(++::eventData.waitIconCount > 10){
          ::eventData.refObj.reset();
          ::eventData.isAutoEvent = true;
          ::eventData.isEventEnd = true;
        }
      break;
    }
  }

}
}

load();
