function load(){

SquirrelPoint <- class
{
  x = 0.0;
  z = 0.0;
  count = 0;
}


SquirrelClass <- class extends NpcClass
{
  KEY_OFFER = "SQUIRREL_OFFER";

  keyObj = null;
  function checkDispKey()
  {
    //\
    if(keyObj != null){
      if(getData(KEY_OFFER) == "close"){
        local rad = pm.ry*PI/180.0;
        keyObj.pm.x = pm.x-sin(rad)*5.0;
        keyObj.pm.y = pm.y+5.0;
        keyObj.pm.z = pm.z-cos(rad)*5.0;
        keyObj.mode = -1;
        keyObj.pm.update();
        keyObj.refObj = null;
        keyObj = null;
        return true;
      }
    }
    return false;
  }

  //public
  constructor(){
    type = "SquirrelClass";
    pm = PorigonManager();
  }

  points = null;
  pointsIndex = 0;
  waitCount = 0;

  basePos = null;
  nextPos = null;
  rad = 0.0;
  mode = 0;
  _mainMode = "find";
  _canMove = true;
  _baseRY = 0.0;

  function _setPoint(index,x,z,count)
  {
    points[index] = SquirrelPoint();
    points[index].x = x;
    points[index].z = z;
    points[index].count = count;
  }

  function _getRY(srcX,srcZ,descX,descZ)
  {
    local result = 0.0;
    local tempX = srcX - descX;
    local tempZ = srcZ - descZ;
    if(tempX == 0.0){
      if(tempZ < 0.0){
        result = 0.0;
      }
      else{
        result = 180.0;
      }
    }
    else{
      result = atan2(tempX,tempZ)*180.0/PI;
      if(result < 0.0){
        result += 360.0;
      }
    }
    if(result >= 360.0){
      result -= 360.0;
    }

    return result;
  }

  function _getSabun(src,desc)
  {
    local sabun = 0.0;

    if(src > desc){
      if(src-180.0 > desc){
        desc += 360.0;
      }
    }
    else{
      if(desc-180.0 > src){
        src += 360.0;
      }
    }

    local result = src - desc;
    return result;
  }

  static POINTS_MAX = 3;

  //pNX
  function subLoad()
  {
    points = array(POINTS_MAX);
    _setPoint(0, -200.0, -100.0, 10);
    _setPoint(1, -300.0, -130.0, 10);
    _setPoint(2, -250.0, -110.0, 10);

    basePos = points[0].weakref();
    nextPos = points[0].weakref();
    pointsIndex = 0;

    switch(getData(KEY_OFFER)){
      case "wait":
        pm.animeIndex = 4;
        pm.animeFrame = 0.0;
      case "close":
        pm.animeIndex = 4;
        pm.animeFrame = 0.0;
      case "closeNoUse":
        _mainMode = "wait";

        if(getData(KEY_OFFER)=="closeNoUse"){
          pm.animeIndex = 2;
          pm.animeFrame = 0.0;
        }
      break;
    }
    if(_mainMode=="find"){
      pm.ry = rad = _getRY(basePos.x,basePos.z,nextPos.x,nextPos.z);
      pm.x = basePos.x;
      pm.y = 0.0;
      pm.z = basePos.z;
      mode = 100;
    }
  }

  function subRun()
  {
    switch(_mainMode){
      case "find":
        if(_canMove == false){
          return;
        }
        switch(mode){
          //]
          case 0:
            local sabunRad = _getSabun(pm.ry,rad);
            if(sabunRad < 0.0){
              pm.ry += 10.0;
              if(pm.ry >= 360.0){
                pm.ry -= 360.0;
              }
              if(_getSabun(pm.ry,rad) > 0.0){
                pm.ry = rad;
              }
            }
            if(sabunRad > 0.0){
              pm.ry -= 10.0;
              if(pm.ry < 0.0){
                pm.ry += 360.0;
              }
              if(_getSabun(pm.ry,rad) < 0.0){
                pm.ry = rad;
              }
            }
            if(sabunRad == 0.0){
              mode = 10;
            }
          break;

          //ړ
          case 10:
            local isEndXZ = false;
            local rote = rad*PI/180.0;
            pm.x -= sin(rote)*0.5;
            pm.z -= cos(rote)*0.5;
            if(sqrt(pow(pm.x-nextPos.x,2)+pow(pm.z-nextPos.z,2)) < 1.0){
              pm.x = nextPos.x;
              pm.z = nextPos.z;
              isEndXZ = true;
            }

            if(isEndXZ){
              mode = 20;

              pm.animeIndex = 1;
              pm.animeFrame = 0.0;
              isAnimeLoop = false;
            }
          break;

          case 20:
            if(pm.animeFrame >= pm.getMaxAnimeFrame(pm.animeIndex)){
              mode = 21;

              pm.animeIndex = 2;
              pm.animeFrame = 0.0;
            }
          break;

          case 21:
            if(pm.animeFrame >= pm.getMaxAnimeFrame(pm.animeIndex)){
              mode = 25;
            }
          break;

          //ҋ@
          case 25:
            if(++waitCount >= nextPos.count){
              waitCount = 0;
              mode = 100;
            }
          break;

          //ړ̐ݒ
          case 100:
            local basePosIndex = pointsIndex;
            if(++pointsIndex >= POINTS_MAX){
              pointsIndex = 0;
            }
            basePos = points[basePosIndex].weakref();
            nextPos = points[pointsIndex].weakref();
            rad = _getRY(basePos.x,basePos.z,nextPos.x,nextPos.z);
            mode = 0;
            pm.animeIndex = 0;
            pm.animeFrame = 0.0;
            isAnimeLoop = true;
          break;
        }
      break;
      case "wait":
      break;
    }
  }

  //eventProc
  function eventProc(){
    ::eventData.windowBaseY = 20.0;
    switch(::eventData.eventCount){
      case 0:
        switch(getData(KEY_OFFER)){
          case "":
            ::eventData.isAutoEvent = true;
          break;
          case "on":
            if(::itemManager.get(ItemClass.NUTS) > 0){
              ::eventData.eventCount = 10;
              _canMove = false;
            }
            else{
              ::eventData.isAutoEvent = true;
            }
          break;
          case "wait":
            if(::itemManager.get(ItemClass.NUTS) > 0){
              ::eventData.eventCount = 20;
            }
            else{
              ::eventData.eventCount = 50;
            }
            _canMove = false;
          break;
          case "close":
            ::eventData.eventCount = 30;
            _canMove = false;
          break;
          case "closeNoUse":
            ::eventData.eventCount = 53;
            _canMove = false;
          break;
        }
        _baseRY = pm.ry;
        if(::eventData.eventCount > 0){
          pm.ry = _getRY(pm.x,pm.z,::playerTask.pm.x,::playerTask.pm.z);
        }
        ::eventData.isResetPlayVoice = true;
      break;

      case 1:
        ::eventData.voiceMsg = "ǂɁA߂ȁ[";
        ::eventData.eventMsg = "ǂ\n߂Ȃ";
      break;
      case 2:
        setData(KEY_OFFER,"on");
        if(::itemManager.get(ItemClass.NUTS) > 0){
          ::eventData.eventCount = 10;
          pm.ry = _getRY(pm.x,pm.z,::playerTask.pm.x,::playerTask.pm.z);
          _canMove = false;
          ::eventData.isResetPlayVoice = true;
        }
        else{
          ::eventData.isAutoEvent = true;
          ::eventData.isEventEnd = true;
          ::eventData.eventMsg = "";
          _canMove = true;
        }
      break;

      case 10:
        ::eventData.voiceMsg = "/ǂ񂮂/Ȃł";
        ::eventData.eventMsg = "\nhO\nȂłI";
      break;
      case 11:
        ::eventData.voiceMsg = "ڂ/ǂ񂮂/܂񂩁H";
        ::eventData.eventMsg = "{N\nhO\n܂񂩁H";
      break;
      case 12:
        ::eventData.voiceMsg = "łˁBɂ߂܂ˁB";
        ::eventData.eventMsg = "EEEł\n\n߂܂";
      break;
      case 13:
        ::eventData.voiceMsg = "̂ȂAĂ";
        ::eventData.eventMsg = "̂Ȃ\n\nĂ";
      break;
      case 14:
        ::eventData.isEventEnd = true;
        ::eventData.isAutoEvent = true;
        ::eventData.eventMsg = "";
        setData(KEY_OFFER,"wait");
        _mainMode = "wait";
        _canMove = true;
        pm.ry = _baseRY;
        pm.animeIndex = 4;
        pm.animeFrame = 0.0;
      break;

      case 20:
        ::eventData.isHukidasi = false;
        ::eventData.voiceMsg = "ǂ񂮂肨A";
        ::eventData.eventMsg = "hO";
      break;
      case 21:
        ::eventData.voiceMsg = "肪Ƃ܂Bꂢɂ܂";
        ::eventData.eventMsg = "肪Ƃ\n܂\nꂢ\n܂";
      break;
      case 22:
        ::eventData.isAutoEvent = true;
        ::eventData.eventMsg = "";
        setData(KEY_OFFER,"close");
        _mainMode = "wait";
        ::itemManager.set(ItemClass.NUTS,-1);
        _canMove = true;
        isAnimeLoop = true;
        pm.animeIndex = 4;
        pm.animeFrame = 0.0;

        checkDispKey();
      break;
      case 23:
        ::eventData.voiceMsg = "̂A炩AĂ̂ł";
        ::eventData.eventMsg = "̂\n炩\nĂ̂łB";
        ::eventData.isEventEnd = true;
      break;

      case 30:
        ::eventData.voiceMsg = "łڂ݂Ƃɂł邼";
        ::eventData.eventMsg = "Ń{N\n݂Ƃ\nł邼";
      break;
      case 31:
        ::eventData.voiceMsg = "悩";
        ::eventData.eventMsg = "悩EEE";
      break;
      case 32:
        ::eventData.isEventEnd = true;
        ::eventData.isAutoEvent = true;
        ::eventData.eventMsg = "";
        _mainMode = "wait";
        _canMove = true;
        isAnimeLoop = true;
      break;

      case 50:
        ::eventData.voiceMsg = "ׂ̂ЂƂɁA/ǂ񂮂/̂łH";
        ::eventData.eventMsg = "ׂ̂ЂƂ\nhO\n̂łH";
      break;
      case 51:
        ::eventData.voiceMsg = "܁A܂ÂAɂ߂łH";
        ::eventData.eventMsg = "܁A܂\n̂\nɂ\n߂łH";
      break;
      case 52:
        pm.animeIndex = 2;
        pm.animeFrame = 0.0;
        isAnimeLoop = true;
        ::eventData.isAutoEvent = true;
        ::eventData.voiceMsg = "";
        ::eventData.eventMsg = "EEE";
      break;
      case 53:
        ::eventData.voiceMsg = "";
        ::eventData.eventMsg = "EEE";
      break;
      case 54:
        ::eventData.isEventEnd = true;
        ::eventData.isAutoEvent = true;
        ::eventData.eventMsg = "";
        setData(KEY_OFFER,"closeNoUse");
      break;
    }
  }
}

}

load();
