function load(){
SquirrelWClass <- class extends NpcClass
{
  KEY_OFFER = "SQUIRRELW_OFFER";

  keyObj = null;
  function checkDispKey()
  {
    //\
    if(keyObj != null){
      if(getData(KEY_OFFER) == "close"){
        local rad = pm.ry*PI/180.0;
        keyObj.pm.x = pm.x-sin(rad)*5.0;
        keyObj.pm.y = pm.y+5.0;
        keyObj.pm.z = pm.z-cos(rad)*5.0;
        keyObj.mode = -1;
        keyObj.pm.update();
        keyObj.refObj = null;
        keyObj = null;
        return true;
      }
    }
    return false;
  }

  _baseRY = 0.0;

  //public
  constructor(){
    type = "SquirrelWClass";
    pm = PorigonManager();
  }

  function _getRY(srcX,srcZ,descX,descZ)
  {
    local result = 0.0;
    local tempX = srcX - descX;
    local tempZ = srcZ - descZ;
    if(tempX == 0.0){
      if(tempZ < 0.0){
        result = 0.0;
      }
      else{
        result = 180.0;
      }
    }
    else{
      result = atan2(tempX,tempZ)*180.0/PI;
      if(result < 0.0){
        result += 360.0;
      }
    }
    if(result >= 360.0){
      result -= 360.0;
    }

    return result;
  }

  //pNX
  function subLoad()
  {
    _baseRY = pm.ry;
    pm.animeIndex = 3;
  }

  function subRun()
  {
  }

  //eventProc
  function eventProc(){
    ::eventData.windowBaseY = 20.0;
    switch(::eventData.eventCount){
      case 0:
        switch(getData(KEY_OFFER)){
          case "":
            ::eventData.isAutoEvent = true;
          break;
          case "on":
            if(::itemManager.get(ItemClass.NUTS) > 0){
              ::eventData.eventCount = 10;
            }
            else{
              ::eventData.eventCount = 1;
            }
          break;
          case "wait":
            if(::itemManager.get(ItemClass.NUTS) > 0){
              ::eventData.eventCount = 20;
            }
            else{
              ::eventData.eventCount = 50;
            }
          break;
          case "close":
            ::eventData.eventCount = 30;
          break;
          case "closeNoUse":
            ::eventData.eventCount = 52;
          break;
        }
        ::eventData.isResetPlayVoice = true;
        pm.ry = _getRY(pm.x,pm.z,::playerTask.pm.x,::playerTask.pm.z);
      break;

      case 1:
        ::eventData.voiceMsg = "/ǂ񂮂/Aǂɂ߂A킷Ȃ";
        ::eventData.eventMsg = "hO\nǂɂ߂A\n킷Ȃ";
      break;
      case 2:
        ::eventData.voiceMsg = "܂AȂĂ܂ʂȂ̂";
        ::eventData.eventMsg = "܂A\nȂă}kP\nȂ̂I";
      break;
      case 3:
        setData(KEY_OFFER,"on");
        if(::itemManager.get(ItemClass.NUTS) > 0){
          ::eventData.eventCount = 10;
          ::eventData.isResetPlayVoice = true;
        }
        else{
          ::eventData.isAutoEvent = true;
          ::eventData.isEventEnd = true;
          ::eventData.eventMsg = "";
          pm.ry =  _baseRY;
        }
      break;

      case 10:
        ::eventData.voiceMsg = "H/ǂ񂮂/Ȃ́H";
        ::eventData.eventMsg = "H\n\nhO\nȂ́H";
      break;
      case 11:
        ::eventData.voiceMsg = "䂸ĂȂH";
        ::eventData.eventMsg = "䂸\nȂH";
      break;
      case 12:
        ::eventData.voiceMsg = "[BɂȂĂB";
        ::eventData.eventMsg = "A\nȂĂ\n";
      break;
      case 13:
        ::eventData.voiceMsg = "䂸Ă邫ɂȂAĂ";
        ::eventData.eventMsg = "䂸Ă\nɂȂA\nĂ";
      break;
      case 14:
        ::eventData.isEventEnd = true;
        ::eventData.isAutoEvent = true;
        ::eventData.eventMsg = "";
        pm.ry =  _baseRY;
        setData(KEY_OFFER,"wait");
      break;

      case 20:
        ::eventData.isHukidasi = false;
        ::eventData.voiceMsg = "ǂ񂮂肨A";
        ::eventData.eventMsg = "hO";
      break;
      case 21:
        ::eventData.voiceMsg = "肪ƂB킨ꂢ";
        ::eventData.eventMsg = "肪ƂI\n͂ꂢ";
      break;
      case 22:
        ::eventData.isAutoEvent = true;
        ::eventData.eventMsg = "";
        setData(KEY_OFFER,"close");
        ::itemManager.set(ItemClass.NUTS,-1);

        checkDispKey();

        pm.ry =  _baseRY;
      break;
      case 23:
        ::eventData.voiceMsg = "̂A炩AĂ";
        ::eventData.eventMsg = "̂\n炩\nĂ";
        ::eventData.isEventEnd = true;
      break;

      case 30:
        ::eventData.voiceMsg = "ȂA₭ɂ";
        ::eventData.eventMsg = "_i\n₭ɂ";
      break;
      case 31:
        ::eventData.isEventEnd = true;
        ::eventData.isAutoEvent = true;
        ::eventData.eventMsg = "";
        pm.ry =  _baseRY;
      break;

      case 50:
        ::eventData.voiceMsg = "H/ǂ񂮂/ÁH";
        ::eventData.eventMsg = "H\nhOA\ńH";
      break;
      case 51:
        ::eventData.voiceMsg = "ǂAɂ邾ȂɂłH";
        ::eventData.eventMsg = "ǂ\nɂ邾Ȃ\nłH";
      break;
      case 52:
        ::eventData.voiceMsg = "܂Â߂Ȃ";
        ::eventData.eventMsg = "܂\ñ__i\ńEEE";
      break;
      case 53:
        ::eventData.isEventEnd = true;
        ::eventData.isAutoEvent = true;
        ::eventData.eventMsg = "";
        pm.ry =  _baseRY;
        setData(KEY_OFFER,"closeNoUse");
      break;
    }
  }
}

}

load();
