function load(){
BaseWhaleClass <- class extends Task
{
  pm=null;
  
  _baseSizeX = 1.0;
  _baseSizeZ = 1.0;
  _isBox = true;
  _onTask = null;
  _onTaskX = 0.0;
  _onTaskY = 0.0;
  _onTaskZ = 0.0;
  _onTaskRY = 0.0;
  
  //public
  constructor(){
    type = "BaseWhaleClass";
    pm = PorigonManager();
  }
  
  //bZ[WM
  function recvMessage(message,obj){
    if(message=="HitObst"){
      if(obj.pm.getCheckObstResultIndex() == pm.index){
        _setOnTask(obj,false);
        obj.pm.clearCheckObstResultIndex();
      }
    }
    if(message=="HitObstHold"){
      if(obj.pm.getCheckObstResultIndex() == pm.index){
        _setOnTask(obj,true);
        obj.pm.clearCheckObstResultIndex();
      }
    }
    if(message=="NoHitObst"){
      _onTask = null;
    }
  }

  function run(){
    local oldX = pm.x;
    local oldY = pm.y;
    local oldZ = pm.z;

    subRun();

    if(_onTask != null){
      local rad = pm.ry*PI/180.0;
      
      _onTask.pm.x = pm.x + sin(rad)*_onTaskX - cos(rad)*_onTaskZ;
      _onTask.pm.z = pm.z + sin(rad)*_onTaskZ + cos(rad)*_onTaskX;
      _onTask.pm.y = pm.y + _onTaskY;
      _onTask.pm.ry = pm.ry + _onTaskRY;
      if(_onTask.pm.ry < 0.0){
        _onTask.pm.ry += 360.0;
      }
      if(_onTask.pm.ry >= 360.0){
        _onTask.pm.ry -= 360.0;
      }
    }
    pm.update();
  }

  function draw(){
    if(pm.checkHit(playerTask.pm.x,playerTask.pm.y-1.0,playerTask.pm.z,
       cameraTask.itiX,cameraTask.itiY+2.0,cameraTask.itiZ)){
       pm.isSetColor = true;
       pm.colorA = 0.25;
       pm.isDrawShadow = false;
    }
    else{
       pm.isSetColor = false;
       pm.colorA = 1.0;
       pm.isDrawShadow = true;
    }

    pm.draw();
  }
  
  function loadPorigon(filename){
    pm.index = index;
    if(pm.load(filename)==false){
      print("error");
    }

    subLoad();

    local shadowTask = ShadowClass();
    shadowTask.refObj = this.weakref();
    shadowTask.isBox = _isBox;
    shadowTask.baseSizeX = _baseSizeX;
    shadowTask.baseSizeZ = _baseSizeZ;
    shadowTask.pm.update();
    ::taskManager.add(shadowTask);
  }

  //Cxg(CxgAIuWFNgj
  function event(eventName,argObj)
  {
    switch(eventName){
      case "onUnload":
        pm.unload();
      break;
    }
  }

  function _setOnTask(obj,isHold)
  {
    _onTask = obj;
    local x = obj.pm.x - pm.x;
    local z = obj.pm.z - pm.z;
    local rad = PI - pm.ry*PI/180.0;
   
    _onTaskX = sin(rad)*x-cos(rad)*z;
    _onTaskZ = sin(rad)*z+cos(rad)*x;
    if(isHold){
      _onTaskY = obj.pm.y - pm.y - obj.addHeadY;
    }
    else{
      _onTaskY = obj.pm.y - pm.y;
    }
    _onTaskRY = obj.pm.ry - pm.ry;
  }
}

WhaleTailClass <- class extends BaseWhaleClass
{
  refWhaleBody = null;

  _isUp = true;
  addRx = 0.0;

  function subLoad()
  {
    type = "WhaleTailClass";
    pm.hitRadius = 30.0;
    _baseSizeX = 30.0;
    _baseSizeZ = 20.0;
  }

  function subRun()
  {
    if(refWhaleBody != null){
      local rad = refWhaleBody.pm.ry * PI / 180.0;
      pm.x = 50.0*sin(rad) + refWhaleBody.pm.x;
      pm.z = 50.0*cos(rad) + refWhaleBody.pm.z;
      pm.y = refWhaleBody.pm.y;
      pm.ry = refWhaleBody.pm.ry;

      if(_isUp){
        addRx -= 1.0;
        if(addRx <= -15.0){
          _isUp = false;
        }
      }
      else{
        addRx += 1.0;
        if(addRx >= 15.0){
          _isUp = true;
        }
      }
      pm.rx = addRx;
      if(pm.rx < 0.0){
        pm.rx += 360.0;
      }
    }
  }
}

WhalePoint <- class
{
  x = 0.0;
  y = 0.0;
  z = 0.0;
  count = 0;
}

WhaleBodyClass <- class extends BaseWhaleClass
{
  points = null;
  pointsIndex = 0;
  waitCount = 0;

  basePos = null;
  nextPos = null;
  rad = 0.0;
  mode = 0;

  function _setPoint(index,x,y,z,count)
  {
    points[index] = WhalePoint();
    points[index].x = x;
    points[index].y = y;
    points[index].z = z;
    points[index].count = count;
  }

  function _getRY(srcX,srcZ,descX,descZ)
  {
    local result = 0.0;
    local tempX = srcX - descX;
    local tempZ = srcZ - descZ;
    if(tempX == 0.0){
      if(tempZ < 0.0){
        result = 0.0;
      }
      else{
        result = 180.0;
      }
    }
    else{
      result = atan2(tempZ,tempX)*180.0/PI;
      if(result < 0.0){
        result += 360.0;
      }
    }
    result+=90.0
    if(result >= 360.0){
      result -= 360.0;
    }

    return result;
  }

  function _getSabun(src,desc)
  {
    local sabun = 0.0;

    if(src > desc){
      if(src-180.0 > desc){
        desc += 360.0;
      }
    }
    else{
      if(desc-180.0 > src){
        src += 360.0;
      }
    }

    local result = src - desc;
    return result;
  }

  static POINTS_MAX = 7;
  function subLoad()
  {
    type = "WhaleBodyClass";
    pm.hitRadius = 30.0;
    _baseSizeX = 20.0;
    _baseSizeZ = 70.0;
    local tailTask = WhaleTailClass();
    tailTask.refWhaleBody = this.weakref();
    ::taskManager.add(tailTask);
    tailTask.loadPorigon("data\\whale\\whaleTail.cha");
    tailTask.pm.update();

    points = array(POINTS_MAX);
    _setPoint(0, 450.0, 10.0, -150.0, 200);
    _setPoint(1, 420.0,80.0, -150.0, 2);
    _setPoint(2, 0.0,  100.0, -150.0, 2);
    _setPoint(3, -100.0,100.0,-150.0, 50);
    _setPoint(4, 0.0,  100.0, -150.0, 2);
    _setPoint(5, 420.0,80.0, -150.0, 2);
    _setPoint(6, 450.0, 10.0, -150.0, 10);

    basePos = points[0].weakref();
    nextPos = points[0].weakref();
    pointsIndex = 0;
    pm.ry = rad = _getRY(basePos.x,basePos.z,nextPos.x,nextPos.z);
    pm.x = basePos.x;
    pm.y = basePos.y;
    pm.z = basePos.z;
    mode = 20;
  }

  function subRun()
  {
    switch(mode){
      //]
      case 0:
        local sabunRad = _getSabun(pm.ry,rad);
        if(sabunRad < 0.0){
          pm.ry += 10.0;
          if(pm.ry >= 360.0){
            pm.ry -= 360.0;
          }
          if(_getSabun(pm.ry,rad) > 0.0){
            pm.ry = rad;
          }
        }
        if(sabunRad > 0.0){
          pm.ry -= 10.0;
          if(pm.ry < 0.0){
            pm.ry += 360.0;
          }
          if(_getSabun(pm.ry,rad) < 0.0){
            pm.ry = rad;
          }
        }
        if(sabunRad == 0.0){
          mode = 10;
        }
      break;

      //ړ
      case 10:
        local isEndXZ = false;
        local rote = (360.0-rad)*PI/180.0;
        pm.x += sin(rote)*0.5;
        pm.z += cos(rote)*0.5;
        if(rad != _getRY(pm.x,pm.z,nextPos.x,nextPos.z)){
          pm.x = nextPos.x;
          pm.z = nextPos.z;
          isEndXZ = true;
        }

        if(basePos.y < nextPos.y){
          pm.y += 0.5;
          if(pm.y >= nextPos.y){
            pm.y = nextPos.y;
          }
        }
        if(basePos.y > nextPos.y){
          pm.y -= 0.5;
          if(pm.y <= nextPos.y){
            pm.y = nextPos.y;
          }
        }
        if(pm.y==nextPos.y && isEndXZ){
          mode = 20;
        }
      break;

      //ҋ@
      case 20:
        if(++waitCount >= nextPos.count){
          waitCount = 0;
          mode = 100;
        }
      break;

      //ړ̐ݒ
      case 100:
        local basePosIndex = pointsIndex;
        if(++pointsIndex >= POINTS_MAX){
          pointsIndex = 0;
        }
        basePos = points[basePosIndex].weakref();
        nextPos = points[pointsIndex].weakref();

        rad = _getRY(basePos.x,basePos.z,nextPos.x,nextPos.z);
        mode = 0;
      break;
    }
  }
}

}

load();
