function load(){
YadokariClass <- class extends NpcClass
{
  KEY_OFFER = "YADOKARI_OFFER";
  refShell = null;
  time = 0.0;
  _minDis = 10.0;
  _isAsyncShell = true;
  _eventRefShellSP = null;
  _walkMode = "wait";
  _baseX=0.0;
  _baseZ=0.0;
  _targetX=0.0;
  _targetZ=0.0;

  //public
  constructor(){
    type = "YadokariClass";
    pm = PorigonManager();
    g=G_MAX;
    isEnableMessage = false;

    if(getData("shell_yadokari") == ""){
      local task = ShellClass();
      task.name = "shell";
      taskManager.add(task);
      task.pm.update();
      task.loadPorigon("data\\field\\parts\\shells\\shell_s.cha");
      task.setItemDataKey("shell_yadokari");
      task.refObj = this.weakref();
      refShell = task.weakref();
      task.checkGetItem();
    }
    else{
      local task = ShellNormalClass();
      task.name = "shell";
      taskManager.add(task);
      task.pm.update();
      task.loadPorigon("data\\field\\parts\\shells\\shell_n.cha");
      task.refObj = this.weakref();
      refShell = task.weakref();
    }
  }

  function _getRY(srcX,srcZ,descX,descZ)
  {
    local result = 0.0;
    local tempX = srcX - descX;
    local tempZ = srcZ - descZ;
    if(tempX == 0.0){
      if(tempZ < 0.0){
        result = 0.0;
      }
      else{
        result = 180.0;
      }
    }
    else{
      result = atan2(tempX,tempZ)*180.0/PI;
      if(result < 0.0){
        result += 360.0;
      }
    }
    if(result >= 360.0){
      result -= 360.0;
    }

    return result;
  }
  //Cxg(CxgAIuWFNgj
  function event(eventName,argObj)
  {
    switch(eventName){
      case "onLoad":
        _baseX = pm.x;
        _baseZ = pm.z;
      break;
      case "onUnload":
        pm.unload();
      break;
    }
  }

  //pNX
  function subRun()
  {
    if(::gameMode == "Walk"){
      switch(_walkMode){
        case "wait":
          time += 0.0125;
          if(time >= 1.0){
            time = 0.0;
            
            pm.ry += 10.0;
            if(pm.ry >= 360.0){
              pm.ry -= 360.0;
            }
            pm.animeIndex = 1;
            pm.animeFrame = 0.0;
            _walkMode = "move";
            
            local rad = pm.ry*PI/180.0;
            _targetX = _baseX - sin(rad)*30.0;
            _targetZ = _baseZ - cos(rad)*30.0;
            pm.ry = _getRY(pm.x,pm.z,_targetX,_targetZ);
          }
        break;
        case "move":
          pm.update();

          local rad = pm.ry*PI/180.0;
          pm.x -= sin(rad)*0.5;
          pm.z -= cos(rad)*0.5;
          
          local resultObst = pm.checkObst(-1,true);
          local resultField = pm.checkField(false);
          
          if(sqrt(pow(_targetX-pm.x,2)+pow(_targetZ-pm.z,2)) <= 2.0 || resultObst>0 || resultField>=2){
            pm.animeIndex = 0;
            pm.animeFrame = 0.0;
            _walkMode = "wait";
          }
        break;
      }
    }

    if(_isAsyncShell == true  && refShell != null){
      local rad = pm.ry * PI / 180.0;

      refShell.pm.x = pm.x + sin(rad)*2.0;
      refShell.pm.y = pm.y - 1.0;
      refShell.pm.z = pm.z + cos(rad)*2.0;
      refShell.pm.ry = pm.ry+180.0;
      while(refShell.pm.ry >= 360.0){
        refShell.pm.ry -= 360.0;
      }
    }
  }

  //eventProc
  function eventProc(){
    ::eventData.windowBaseY = 10.0;
    switch(::eventData.eventCount){
      case 0:
        pm.animeIndex = 0;
        pm.animeFrame = 0.0;
        _walkMode = "wait";
        pm.ry = _getRY(pm.x,pm.z,::playerTask.pm.x,::playerTask.pm.z);
        if(getData(KEY_OFFER) == ""){
          setData(KEY_OFFER,"start");
          ::eventData.isAutoEvent = true;
        }
        else{
          if(getData(KEY_OFFER) == "start"){
            ::eventData.eventCount = 2;
          }
          else{
            ::eventData.eventCount = 100;
          }
          ::eventData.isResetPlayVoice = true;
        }
      break;
      case 1:
        ::eventData.voiceMsg = "̂A҂҂";
        ::eventData.eventMsg = "̂A\n҂҂";
      break;
      case 2:
        ::eventData.voiceMsg = "//ȂAȂ";
        ::eventData.eventMsg = "ƁA\nW~Ȃ\nȂH";
        if(::itemManager.get(ItemClass.SHELL_NORMAL) < 1){
          ::eventData.isEventEnd = true;
        }
      break;
      case 3:
        ::eventData.isResetPlayVoice = true;
        ::eventData.eventCount = 10;
      break;

      case 10:
        ::eventData.voiceMsg = "Ȃ́Â";
        ::eventData.eventMsg = "Ȃ\n̂";
      break;
      case 11:
        ::eventData.voiceMsg = "񂵂ĂȂ";
        ::eventData.eventMsg = "񂵂\nȂH";
      break;
      case 12:
        ::eventData.isHukidasi = false;
        ::eventData.voiceMsg = "݂ȂA";
        ::eventData.eventMsg = "W~Ȃ";
      break;
      case 13:
        ::itemManager.set(ItemClass.SHELL_NORMAL,-1)
        setData(KEY_OFFER,"close");
        _eventRefShellSP = refShell;
        refShell.refObj = null;
        refShell = null;
        ::eventData.isAutoEvent = true;

        local rad = pm.ry+90.0;
        if(rad >= 360.0){
          rad -= 360.0;
        }
        rad = rad * PI / 180.0;

        local task = ShellNormalClass();
        task.name = "shell";
        task.pm.x = pm.x + sin(rad)*_minDis;
        task.pm.y = pm.y;
        task.pm.z = pm.z + cos(rad)*_minDis;
        taskManager.add(task);
        task.pm.update();
        task.loadPorigon("data\\field\\parts\\shells\\shell_n.cha");
        task.refObj = this.weakref();
        refShell = task.weakref();
        _isAsyncShell = false;

        //look
        pm.ry = _getRY(pm.x,pm.z,refShell.pm.x,refShell.pm.z);
        ::eventData.pushedButton1 = true;
        pm.animeIndex = 1;
        pm.animeFrame = 0.0;
      break;

      case 14:
        ::eventData.pushedButton1 = true;
        local rad = pm.ry * PI / 180.0;
        pm.x-=sin(rad)*0.5;
        pm.z-=cos(rad)*0.5;

        rad = sqrt(pow(pm.x-refShell.pm.x,2)+pow(pm.z-refShell.pm.z,2));
        if(rad <= 3.0){
          ::eventData.isAutoEvent = true;
          time = 0.0;
          pm.ry += 180.0;
          if(pm.ry >= 360.0){
            pm.ry -= 360.0;
          }
          _isAsyncShell = true;
          pm.animeIndex = 0;
          pm.animeFrame = 0.0;
        }
      break;
      case 15:
        ::eventData.eventCount = 30;
        _eventRefShellSP.pm.x = ::playerTask.pm.x;
        _eventRefShellSP.pm.z = ::playerTask.pm.z;
      break;

      case 30:
        ::eventData.isEventEnd = true;
        ::eventData.isAutoEvent = true;
      break;

      case 100:
        ::eventData.voiceMsg = "̂A킽݂̂傭ЂAȂ";
        ::eventData.eventMsg = "̂\n킽݂̂傭\nЂA\nȂ";
        ::eventData.isEventEnd = true;
      break;
    }
  }
}
}

load();
