function load(){
FallingObjClass <- class extends Task
{
  baseSizeX = 1.0;
  baseSizeZ = 1.0;
  isBox = false;

  static MODE_WAIT = 0;
  static MODE_ON = 10;
  static MODE_FALL = 20;
  static MODE_REV = 30;
  static MODE_REVWAIT = 40;

  pm=null;
  
  waitMaxCount = 50;
  revMaxCount = 10;
  revWaitMaxCount = 50;
  
  baseX = 0.0;
  baseY = 0.0;
  baseZ = 0.0;
  count = 0;
  mode = 0;
  
  onTask = null;
  
  //public
  constructor(){
    type = "FallingObjClass";
    pm = PorigonManager();
  }
  
  //bZ[WM
  function recvMessage(message,obj){
    if(message=="HitObst" || message=="HitObstHold"){
      if(obj.pm.getCheckObstResultIndex() == pm.index){
        onTask = obj;
        obj.pm.clearCheckObstResultIndex();
      }
    }
    if(message=="NoHitObst"){
      onTask = null;
    }
  }

  function run(){
    local oldX = pm.x;
    local oldY = pm.y;
    local oldZ = pm.z;
    local isMovingPlayer=true;
    local scale=1.0;
    
    local debugModeText = "";
    
    switch(mode){
      case MODE_WAIT:
        if(onTask != null){
          mode = MODE_ON;
          count = 0;
        }
        debugModeText="MODE_WAIT";
      break;
      case MODE_ON:
        if(++count >= waitMaxCount){
          mode = MODE_FALL;
          count = 0;
        }
        else{
          if(count%10 == 4){
            playWave(waveFallingObj);
          }
        }
        local shakeTime = waitMaxCount.tofloat()/5.0;
        local per = count.tofloat()/waitMaxCount.tofloat();
        pm.x = baseX + sin(per*PI*shakeTime)*1.0;
        isMovingPlayer = false;
        pm.checkObst(-1,true);

        debugModeText="MODE_ON";
      break;
      case MODE_FALL:
        pm.y -= 1.0;
        local resultField = pm.checkField(false);
        local resultObst = pm.checkObst(-1,true);
        
        if(resultField >= 0 || resultObst>=0){
          mode = MODE_REV;
          count = 0;
          pm.isObst = false;
          if(onTask != null){
            sendMessage("EndHold",onTask.index);
          }
          sendMessage("HideShadow");
        }

        debugModeText="MODE_FALL";
      break;
      case MODE_REV:
        isMovingPlayer = false;
        if(++count >= revMaxCount){
          mode = MODE_REVWAIT;
          count = 0;
          pm.x = baseX;
          pm.y = baseY;
          pm.z = baseZ;
          scale = 0.0;
          sendMessage("ShowShadow");
        }

        debugModeText="MODE_REV";
      break;
      case MODE_REVWAIT:
        isMovingPlayer = false;
        count++;
        if(count >= revWaitMaxCount){
          mode = MODE_WAIT;
          count = 0;
          pm.isObst = true;
          onTask = null;
        }
        else{
          local per = count.tofloat()/revWaitMaxCount.tofloat();
          scale = sin(PI*per*0.5)*1.0;
        }
        
        debugModeText="MODE_REVWAIT";
      break;
    }
    
    setDebugMsg(debugModeText+"["+count+"]");
    
    if(onTask != null && isMovingPlayer){
      onTask.pm.x += (pm.x-oldX);
      onTask.pm.y += (pm.y-oldY);
      onTask.pm.z += (pm.z-oldZ);
    }
  
    if(pm.checkHit(playerTask.pm.x,playerTask.pm.y-1.0,playerTask.pm.z,
       cameraTask.itiX,cameraTask.itiY+2.0,cameraTask.itiZ)){
       pm.isSetColor = true;
       pm.colorA = 0.25;
       pm.isDrawShadow = false;
    }
    else{
      pm.isSetColor = false;
      pm.colorA = 1.0;
      pm.isDrawShadow = true;
      pm.scaleX = scale;
      pm.scaleY = scale;
      pm.scaleZ = scale;
    }
    pm.update();
  }

  function draw(){
    if(mode != MODE_REV){
      pm.draw();
    }
  }
  
  function loadPorigon(filename){
    pm.index = index;
    if(pm.load(filename)==false){
      print("error");
    }
    baseX = pm.x;
    baseY = pm.y;
    baseZ = pm.z;

    local shadowTask = ShadowClass();
    shadowTask.refObj = this.weakref();
    shadowTask.isBox = isBox;
    shadowTask.baseSizeX = baseSizeX;
    shadowTask.baseSizeZ = baseSizeZ;
    shadowTask.pm.update();
    ::taskManager.add(shadowTask);
  }

  //Cxg(CxgAIuWFNgj
  function event(eventName,argObj)
  {
    switch(eventName){
      case "onUnload":
        pm.unload();
      break;
    }
  }
}
}

load();
