function load()
{
  ItemClass <- class
  {
    static NONE          = "KEY_ITEM_NONE";
    static BANANA        = "KEY_ITEM_BANANA";
    static SHELL         = "KEY_ITEM_SHELL";
    static SHELL_NORMAL  = "KEY_ITEM_SHELL_NORMAL";
    static FISH          = "KEY_ITEM_FISH";
    static DIGBOOK       = "KEY_ITEM_DIGBOOK";
    static NUTS          = "KEY_ITEM_NUTS";
    static KEY           = "KEY_ITEM_KEY";
    static GLASS         = "KEY_ITEM_GLASS";
    static LAMP          = "KEY_ITEM_LAMP";

    _type = "KEY_ITEM_NONE";

    constructor(type,count){
      _type = type;
      setData(_type,count.tostring());
    }

    function get()
    {
      return getData(_type).tointeger();
    }

    function add(addCount)
    {
      setData(_type,(get()+addCount).tostring());
    }

    function getName()
    {
      return findName(_type);
    }

    static function findName(type)
    {
      if(type == ItemClass.BANANA){
        return "oii";
      }
      if(type == ItemClass.FISH){
        return "";
      }
      if(type == ItemClass.SHELL){
        return "LCȂ";
      }
      if(type == ItemClass.SHELL_NORMAL){
        return "W~Ȃ";
      }
      if(type == ItemClass.DIGBOOK){
        return "Ȃق̂ق";
      }
      if(type == ItemClass.NUTS){
        return "hO";
      }
      if(type == ItemClass.KEY){
        return "";
      }
      if(type == ItemClass.GLASS){
        return "Rbv";
      }
      if(type == ItemClass.LAMP){
        return "v";
      }
      return "";
    }

    static function getIndex(type)
    {
      if(type == ItemClass.BANANA){
        return 0;
      }
      if(type == ItemClass.SHELL){
        return 1;
      }
      if(type == ItemClass.FISH){
        return 2;
      }
      if(type == ItemClass.SHELL_NORMAL){
        return 3;
      }
      if(type == ItemClass.DIGBOOK){
        return 4;
      }
      if(type == ItemClass.NUTS){
        return 5;
      }
      if(type == ItemClass.KEY){
        return 6;
      }
      if(type == ItemClass.GLASS){
        return 7;
      }
      if(type == ItemClass.LAMP){
        return 8;
      }
      return -1;
    }
  }

  ItemManager <- class 
  {

    _items = null;

    constructor(){
      _items = array(0);

      local value="";
      if((value=getData(ItemClass.BANANA)) != ""){
        set(ItemClass.BANANA,value.tointeger());
      }
      if((value=getData(ItemClass.SHELL)) != ""){
        set(ItemClass.SHELL,value.tointeger());
      }
      if((value=getData(ItemClass.FISH)) != ""){
        set(ItemClass.FISH,value.tointeger());
      }
      if((value=getData(ItemClass.SHELL_NORMAL)) != ""){
        set(ItemClass.SHELL_NORMAL,value.tointeger());
      }
      if((value=getData(ItemClass.DIGBOOK)) != ""){
        set(ItemClass.DIGBOOK,value.tointeger());
      }
      if((value=getData(ItemClass.NUTS)) != ""){
        set(ItemClass.NUTS,value.tointeger());
      }
      if((value=getData(ItemClass.KEY)) != ""){
        set(ItemClass.KEY,value.tointeger());
      }
      if((value=getData(ItemClass.GLASS)) != ""){
        set(ItemClass.GLASS,value.tointeger());
      }
      if((value=getData(ItemClass.LAMP)) != ""){
        set(ItemClass.LAMP,value.tointeger());
      }
    }

    function set(type,addCount)
    {
      local isUpdate = false;
      local deleteIndex = -1;
      foreach(index,obj in _items){
        if(obj._type == type){
          obj.add(addCount);
          if(obj.get() <= 0){
            deleteIndex = index;
          }
          isUpdate = true;
        }
      }
      
      if(isUpdate == false){
        _items.append(ItemClass(type,addCount));
      }
      if(deleteIndex >= 0){
        _items.remove(deleteIndex);
      }
    }

    function get(type)
    {
      foreach(obj in _items){
        if(obj._type == type){
          return obj.get();
        }
      }
      return -1;
    }
  }
}

load();
